#ifndef CHIP_MMAP_N32G03X_H
#define CHIP_MMAP_N32G03X_H

//#include "chip_devtype_mem.h"

/* CODE MEMORY */
#define CHIP_MEMRGN_ADDR_FLASH                0x08000000UL
#define CHIP_MEMRGN_ADDR_OPTION_BYTES         0x1FFFF600UL
#define CHIP_MEMRGN_ADDR_SYSMEM               0x1FFF0000UL


/* RAM */
#define CHIP_MEMRGN_ADDR_SRAM                 0x20000000UL

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB1                 0x40000000UL
#define CHIP_MEMRGN_ADDR_APB2                 0x40010000UL
#define CHIP_MEMRGN_ADDR_AHB                  0x40020000UL
#define CHIP_MEMRGN_ADDR_CM0_INTERNAL         0xE0000000UL


/* Адреса блоков периферии */
#define CHIP_MEMRGN_ADDR_PERIPH_BEEPER1       (CHIP_MEMRGN_ADDR_APB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM3          (CHIP_MEMRGN_ADDR_APB1 + 0x0400) /* = stm */
#if CHIP_DEV_TIM_GP_CNT >= 2
#define CHIP_MEMRGN_ADDR_PERIPH_TIM4          (CHIP_MEMRGN_ADDR_APB1 + 0x0800) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_LPTIM         (CHIP_MEMRGN_ADDR_APB1 + 0x0C00)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM6          (CHIP_MEMRGN_ADDR_APB1 + 0x1000) /* = stm */
#if CHIP_DEV_BEEPER_CNT >= 2
#define CHIP_MEMRGN_ADDR_PERIPH_BEEPER2       (CHIP_MEMRGN_ADDR_APB1 + 0x1400) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_OPAMP         (CHIP_MEMRGN_ADDR_APB1 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_COMP          (CHIP_MEMRGN_ADDR_APB1 + 0x2400)
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB1 + 0x2800) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_WWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x2C00) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_IWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x3000) /* = stm */
#if CHIP_DEV_SUPPORT_TSC
#define CHIP_MEMRGN_ADDR_PERIPH_TSC           (CHIP_MEMRGN_ADDR_APB1 + 0x3400) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB1 + 0x4400) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_LPUART1       (CHIP_MEMRGN_ADDR_APB1 + 0x4800)
#if CHIP_DEV_LPUART_CNT >= 2
#define CHIP_MEMRGN_ADDR_PERIPH_LPUART2       (CHIP_MEMRGN_ADDR_APB1 + 0x4C00) /* !n32g032 only */
#endif
#if CHIP_DEV_UART_CNT >= 3
#define CHIP_MEMRGN_ADDR_PERIPH_UART5         (CHIP_MEMRGN_ADDR_APB1 + 0x5000) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB1 + 0x5400) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_I2C2          (CHIP_MEMRGN_ADDR_APB1 + 0x5800) /* = stm */
#if CHIP_DEV_CAN_CNT >= 1
#define CHIP_MEMRGN_ADDR_PERIPH_CAN1          (CHIP_MEMRGN_ADDR_APB1 + 0x6400) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_PWR           (CHIP_MEMRGN_ADDR_APB1 + 0x7000) /* = stm */

#define CHIP_MEMRGN_ADDR_PERIPH_AFIO          (CHIP_MEMRGN_ADDR_APB2 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTI          (CHIP_MEMRGN_ADDR_APB2 + 0x0400) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOA         (CHIP_MEMRGN_ADDR_APB2 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOB         (CHIP_MEMRGN_ADDR_APB2 + 0x0C00)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOC         (CHIP_MEMRGN_ADDR_APB2 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOD         (CHIP_MEMRGN_ADDR_APB2 + 0x1400) /* !n32g032 only */
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOF         (CHIP_MEMRGN_ADDR_APB2 + 0x1C00)

#define CHIP_MEMRGN_ADDR_PERIPH_SPI1          (CHIP_MEMRGN_ADDR_APB2 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S1          (CHIP_MEMRGN_ADDR_APB2 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM1          (CHIP_MEMRGN_ADDR_APB2 + 0x2C00) /* = stm */
#if CHIP_DEV_SPI_CNT >= 3
#define CHIP_MEMRGN_ADDR_PERIPH_SPI3          (CHIP_MEMRGN_ADDR_APB2 + 0x3000) /* !n32g032 only */
#endif
#define CHIP_MEMRGN_ADDR_PERIPH_TIM8          (CHIP_MEMRGN_ADDR_APB2 + 0x3400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB2 + 0x3800) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_SPI2          (CHIP_MEMRGN_ADDR_APB2 + 0x4400)
#if CHIP_DEV_UART_CNT >= 4
#define CHIP_MEMRGN_ADDR_PERIPH_UART6         (CHIP_MEMRGN_ADDR_APB2 + 0x5000) /* !n32g032 only */
#endif


#define CHIP_MEMRGN_ADDR_PERIPH_DMA           (CHIP_MEMRGN_ADDR_AHB  + 0x0000) /* = stm */
#define CHIP_MEMRGN_ADDR_PERIPH_SQRT          (CHIP_MEMRGN_ADDR_AHB  + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC1          (CHIP_MEMRGN_ADDR_AHB  + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_RCC           (CHIP_MEMRGN_ADDR_AHB  + 0x1000) /* = stm g0 */
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_AHB  + 0x2000) /* = stm g0 */
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           (CHIP_MEMRGN_ADDR_AHB  + 0x3000) /* = stm g0 */
#define CHIP_MEMRGN_ADDR_PERIPH_HDIV          (CHIP_MEMRGN_ADDR_AHB  + 0x8000)


#define CHIP_MEMRGN_ADDR_PERIPH_GPIO(n)       (CHIP_MEMRGN_ADDR_PERIPH_GPIOA + (0x400*n))



#endif // CHIP_MMAP_N32G03X_H
